# 텐서플로(TensorFlow)는 구글에서 개발한 오픈소스 딥러닝 라이브러리
# 머신러닝 모델을 설계, 학습, 평가 및 배포하는 데 사용
# 파이썬을 기반으로 사용하기 쉽고, 다양한 플랫폼과 호환되어 딥러닝 및 머신러닝 학습과 연구에 많이 활용

# 1단계: 환경 설정
# 필요한 라이브러리를 설치
# pip install tensorflow
# GPU 지원 텐서플로 설치
# pip install tensorflow-gpu

import tensorflow as tf
# 텐서플로 버전확인
print("TensorFlow version:", tf.__version__)

# 텐서플로의 주요 구성 요소
# 데이터 파이프라인 구축 (tf.data): 데이터를 효과적으로 불러오고 처리할 수 있도록 돕는 모듈
# 케라스(Keras): 텐서플로에 포함된 고수준 API로, 신경망 모델을 쉽게 구축하고 훈련
# 텐서(Tensor): 텐서플로의 기본 데이터 구조로, 숫자의 다차원 배열
# 오퍼레이션(Operation): 텐서를 조작하고 연산하는 함수나 연산
# 그래프 및 세션(Graph and Session): 최신 버전의 텐서플로에서는 그래프와 세션 개념이 기본적으로 처리
# 그래프 구조로 모델을 표현하고 세션으로 실행하는 것이 기본 개념

# 텐서플로로 딥러닝 모델 구축하기
# 모델을 구축하는 기본 흐름은 데이터 준비, 데이터 전처리, 모델 설계, 모델 컴파일, 모델 학습, 모델 평가


# 데이터 시각화
# pip install matplotlib
import matplotlib.pyplot as plt

# 수학 계산과 배열 처리
import numpy as np